#ifndef _C64_H
#define _C64_H

;// hardware related

#define CIA1 $dc00
#define CIA2 $dd00
#define VIC  $d000

#define CIA1_PRA     CIA1+0       ; port register A (i/o)
#define CIA1_PRB     CIA1+1       ; port register B (i/o)
#define CIA1_DDRA    CIA1+2       ; data direction register A  (0=input,
#define CIA1_DDRB    CIA1+3       ; data direction register B   1=output)
#define CIA1_TALO    CIA1+4       ; timer A bits 0-7 (lo byte)
#define CIA1_TAHI    CIA1+5       ; timer A bits 8-15 (hi byte)
#define CIA1_TBLO    CIA1+6       ; timer B bits 0-7 (lo byte)
#define CIA1_TBHI    CIA1+7       ; timer B bits 8-15 (hi byte)
#define CIA1_TOD10   CIA1+8       ; time of day - 1/10 seconds
#define CIA1_TODSEC  CIA1+9       ; time of day - seconds (in BCD)
#define CIA1_TODMIN  CIA1+10      ; time of day - minutes (in BCD)
#define CIA1_TODHR   CIA1+11      ; time of day - hour + am/pm
#define CIA1_SDR     CIA1+12      ; serial data register (i/o)
#define CIA1_ICR     CIA1+13      ; iterrupt control register
#define CIA1_CRA     CIA1+14      ; control register A
#define CIA1_CRB     CIA1+15      ; control register B

#define CIA2_PRA     CIA2+0       ; port register A (i/o)
#define CIA2_PRB     CIA2+1       ; port register B (i/o)
#define CIA2_DDRA    CIA2+2       ; data direction register A  (0=input,
#define CIA2_DDRB    CIA2+3       ; data direction register B   1=output)
#define CIA2_TALO    CIA2+4       ; timer A bits 0-7 (lo byte)
#define CIA2_TAHI    CIA2+5       ; timer A bits 8-15 (hi byte)
#define CIA2_TBLO    CIA2+6       ; timer B bits 0-7 (lo byte)
#define CIA2_TBHI    CIA2+7       ; timer B bits 8-15 (hi byte)
#define CIA2_TOD10   CIA2+8       ; time of day - 1/10 seconds
#define CIA2_TODSEC  CIA2+9       ; time of day - seconds (in BCD)
#define CIA2_TODMIN  CIA2+10      ; time of day - minutes (in BCD)
#define CIA2_TODHR   CIA2+11      ; time of day - hour + am/pm
#define CIA2_SDR     CIA2+12      ; serial data register (i/o)
#define CIA2_ICR     CIA2+13      ; iterrupt control register
#define CIA2_CRA     CIA2+14      ; control register A
#define CIA2_CRB     CIA2+15      ; control register B

#define VIC_S0X      VIC+0        ; sprite 0 x (bit 7..0)
#define VIC_S0Y      VIC+1        ; sprite 0 y (bit 7..0)
#define VIC_S1X      VIC+2        ; sprite 1 x (bit 7..0)
#define VIC_S1Y      VIC+3        ; sprite 1 y (bit 7..0)
#define VIC_S2X      VIC+4        ; sprite 2 x (bit 7..0)
#define VIC_S2Y      VIC+5        ; sprite 2 y (bit 7..0)
#define VIC_S3X      VIC+6        ; sprite 3 x (bit 7..0)
#define VIC_S3Y      VIC+7        ; sprite 3 y (bit 7..0)
#define VIC_S4X      VIC+8        ; sprite 4 x (bit 7..0)
#define VIC_S4Y      VIC+9        ; sprite 4 y (bit 7..0)
#define VIC_S5X      VIC+10       ; sprite 5 x (bit 7..0)
#define VIC_S5Y      VIC+11       ; sprite 5 y (bit 7..0)
#define VIC_S6X      VIC+12       ; sprite 6 x (bit 7..0)
#define VIC_S6Y      VIC+13       ; sprite 6 y (bit 7..0)
#define VIC_S7X      VIC+14       ; sprite 7 x (bit 7..0)
#define VIC_S7Y      VIC+15       ; sprite 7 y (bit 7..0)
#define VIC_SX8      VIC+16       ; sprite 7..0 x bit 8
#define VIC_YSCL     VIC+17       ; ..., screen y-offset
#define VIC_RC       VIC+18       ; current raster line
#define VIC_LPX      VIC+19       ; light pen x
#define VIC_LPY      VIC+20       ; light pen y
#define VIC_SE       VIC+21       ; sprite 7..0 enable
#define VIC_XSCL     VIC+22       ; ..., screen x-offset
#define VIC_SEXY     VIC+23       ; sprite 7..0 expand y
#define VIC_VSCB     VIC+24       ; ..., location of charset
#define VIC_IRQ      VIC+25       ; interrupt request
#define VIC_IRM      VIC+26       ; interrupt request mask
#define VIC_BSP      VIC+27       ; sprite 7..0 background priority
#define VIC_SCM      VIC+28       ; sprite 7..0 multicolor mode
#define VIC_SEXX     VIC+29       ; sprite 7..0 expand x
#define VIC_SSC      VIC+30       ; sprite-sprite collision (7..0)
#define VIC_SBC      VIC+31       ; sprite-background collision (7..0)
#define VIC_BC       VIC+32       ; border color
#define VIC_GC0      VIC+33       ; background 0 color
#define VIC_GC1      VIC+34       ; background 1 color
#define VIC_GC2      VIC+35       ; background 2 color
#define VIC_GC3      VIC+36       ; background 3 color
#define VIC_SMC0     VIC+37       ; sprite multicolor color 0     
#define VIC_SMC1     VIC+38       ; sprite multicolor color 1
#define VIC_SC0      VIC+39       ; sprite 0 color
#define VIC_SC1      VIC+40       ; sprite 1 color
#define VIC_SC2      VIC+41       ; sprite 2 color
#define VIC_SC3      VIC+42       ; sprite 3 color
#define VIC_SC4      VIC+43       ; sprite 4 color
#define VIC_SC5      VIC+44       ; sprite 5 color
#define VIC_SC6      VIC+45       ; sprite 6 color
#define VIC_SC7      VIC+46       ; sprite 7 color

#endif

