;********************************************
; LUnix - keyscanning
;   invented for old and dusty keyboards :-)
;
; has problems with SHIFT on some emulators (don't exactly know why)
;
; this will become a module in a later version
; (a module that is inserted at startup) 
;********************************************

#include "system.h"
#include MACHINE_H
#include "keyboard.h"

; .extern hook_irq
; .extern printk
; .extern panic

#define  keybuflen 16			; size of keyboard buffer

		port_row equ CIA1_PRA	; selection of rows
		port_col equ CIA1_PRB	; status of columns

btab2i:	.byte $fe, $fd, $fb, $f7, $ef, $df, $bf, $7f

#ifdef petscii

		;; petscii decoding tables
		
_keytab_normal:
		.byte   8, 13,136,134,128,130,132,138
		.byte  51,119, 97, 52,122,115,101,~keyb_lshift
		.byte  53,114,100, 54, 99,102,116,120
		.byte  55,121,103, 56, 98,104,117,118
		.byte  57,105,106, 48,109,107,111,110
		.byte  43,112,108, 45, 46, 58, 64, 44
		.byte  30, 42, 59, 12,~keyb_rshift, 61,124, 47
		.byte  49, 27,~keyb_ctrl, 50, 32,  9,142, 81,146

_keytab_shift:
		.byte 143,144,137,135,129,131,133,139
		.byte  35, 87, 65, 36, 90, 83, 69,255
		.byte  37, 82, 68, 38, 67, 70, 84, 88
		.byte  39, 89, 71, 40, 66, 72, 85, 86
		.byte  41, 73, 74,123, 77, 75, 79, 78
		.byte 125, 80, 76, 95, 62, 91,126, 60
		.byte  92,145, 93,140,255, 96, 20, 63
		.byte  33, 94,255, 34,  9,142, 81,146
#else
		;; UNIX (ascii) decoding tables (default)

#define dunno $7f
#define f1_c            dunno
#define f2_c            dunno
#define f3_c            dunno
#define f4_c            dunno
#define f5_c            dunno
#define f6_c            dunno
#define f7_c            dunno
#define f8_c            dunno
#define pound_c         $1e
#define home_c          dunno
#define arrow_left_c    $1b     ; arrow_left = escape
#define arrow_up_c      $5e		; arrow up = ^
#define csr_up_c        dunno
#define csr_down_c      dunno
#define csr_left_c      dunno
#define csr_right_c     dunno
#define commo_c         $09		; commodore key is tab ?! (you may change it)
#define rs_c            $03		; run/stop = CTRL+c
#define sdel_c          dunno
#define snull_c         $7c     ; shift + 0 = |
#define splus_c         $7b     ; shift + "+" = {
#define smin_c          $7d     ; shift + "-" = }
#define sat_c           $5f     ; shift + @ = _
#define spound_c        $5c     ; shift + pound = \   !
#define sstar_c         $7e     ; shift + * = ~
#define shome_c         dunno
#define sequ_c          dunno
#define sarrow_up_c     $1c     ; shift + arrow_up = pi
#define sarrow_left_c   $60     ; shift + arrow_left = ` (reverse quote)
#define sspc_c          $20     ; shift + space = space
#define scommo_c        dunno
#define srs_c		    dunno

_keytab_normal:
  .byte  $08,$0a,csr_right_c,f7_c,f1_c,f3_c,f5_c,csr_down_c
  .byte  $33,$77,$61,$34,$7a,$73,$65,~keyb_lshift
  .byte  $35,$72,$64,$36,$63,$66,$74,$78
  .byte  $37,$79,$67,$38,$62,$68,$75,$76
  .byte  $39,$69,$6a,$30,$6d,$6b,$6f,$6e
  .byte  $2b,$70,$6c,$2d,$2e,$3a,$40,$2c
  .byte  pound_c, $2a,$3b,home_c,~keyb_rshift,$3d,arrow_up_c,$2f
  .byte  $31,arrow_left_c,~keyb_ctrl,$32,$20,commo_c,$71,rs_c

_keytab_shift:
  .byte  sdel_c,$0a,csr_left_c,f8_c,f2_c,f4_c,f6_c,csr_up_c
  .byte  $23,$57,$41,$24,$5a,$53,$45,$ff
  .byte  $25,$52,$44,$26,$43,$46,$54,$58
  .byte  $27,$59,$47,$28,$42,$48,$55,$56
  .byte  $29,$49,$4a,snull_c,$4d,$4b,$4f,$4e
  .byte  splus_c,$50,$4c,smin_c,$3e,$5b,sat_c,$3c
  .byte  spound_c,sstar_c,$5d,shome_c,$ff,sequ_c,sarrow_up_c,$3f
  .byte  $21,sarrow_left_c,$ff,$22,sspc_c,scommo_c,$51,srs_c
#endif

done:			.buf 8			; map of done keys
last:			.buf 8			; map as is was scanned the last time

ljoy0:			.byte $ff		; last state of joy0
ljoy1:			.byte $ff		; last state of joy1

joy0result:		.byte $ff		; current state of joy0
joy1result:		.byte $ff		; current state of joy1

flag:			.byte 0			; must be zero at startup
lst:			.byte $ff		; must be $ff at startup
          
altflags:		.buf 1			; altflags (was $28d in C64 ROM)
keycode:		.buf 1			; keycode (was $cb in C64 ROM)

keycount:		.byte 0			; number of bytes in buffer
_keybuffer:		.buf keybuflen	; keyboard-buffer

		;; interrupt routine, that scans for keys

	-	lda  port_row
		cmp  port_row
		bne  -
		tax
		and  ljoy0
		sta  joy0result
		stx  ljoy0
	-	lda  port_col
		cmp  port_col
		bne  -
		tax
		and  ljoy1
		sta  joy1result
		stx  ljoy1
		rts
          
keyb_scan:
		ldx  #0
		stx  altflags
		ldy  #$40
		sty  keycode
		lda  #$ff
		sta  port_row			; make sure all lines are high  
		lda  port_row
		and  port_col
		cmp  #$ff				; joystick ??
		bne  --					; skip keysacn and go scanning joysticks

		lda  ljoy0
		sta  joy0result
		lda  ljoy1
		sta  joy1result
		lda  #$ff
		sta  ljoy0
		sta  ljoy1

		ldy  #0
		sty  port_row
	-	lda  port_col			; pressed keys ?
		cmp  port_col
		bne  -
		tax
		and  lst				; maybe at last scan ?
		cmp  #$ff
		beq  +					; no, then skip scanning
		stx  lst				; remember summary
		ldx  #0
		jmp  _keyscan_main
          
 
	+	bit  flag				; if flag is null, skip
		bmi  +
		ldy  #7
		stx  flag				; else flag=null;

	-	txa
		sta  last,y
		lda  #0
		sta  done,y
		dey
		bpl  -					; clear maps

	+	rts						; return to system
          
_keyscan_main:
		lda  btab2i,x			; prepare for scanning one line
		sta  port_row

	-	lda  port_row
		cmp  port_row
		bne  -
		cmp  btab2i,x
		beq  ++					; there are definetely no ghostkeys !

	-	lda  port_col			; take a closer look  
		cmp  port_col			; maybe there are ghostkeys !
		bne  -
		pha						; remember line-pattern
		eor  #$ff
		beq  +					; no cleared bit, then its ok

	-	asl  a
		bcc  -

		beq  +					; only one bit cleared, thats ok too.
								; skip scanning, if there are ghostkeys

		pla						; cleanup stack
		rts						; back to system

	+	pla
		jmp  ++					; some little artwork, to prevent reading
								; port_col a second time

	+ -	lda  port_col
		cmp  port_col
		bne  -
	+	pha						; remember line-pattern
		and  last,x				; add last time result
		pha						; remember this too
		and  done,x				; clear done keys, that are released
		eor  done,x
		sta  done,x
		pla
		ora  done,x				; remove old keys (that are pressed before)
		eor  #$ff
		beq  ++++				; no key left, then continue with next line

	-	lsr  a
		bcc  +++				; not pressed
		pha						; found pressed key
		lda  _keytab_normal,y
		cmp  #240				; some keys are treated more equal !!
		bcc  +
		eor  #$ff
		ora  altflags
		sta  altflags			; altflags contains pattern of shift,commo,..
		bit  flag				; (be sure, flag dosn't stay $ff)
		bpl  ++
		lda  #$40
		sta  flag				; if flag is null, set it to none
		jmp  ++

	+	sty  keycode			; remember key if it is not shift or commo
	+	pla
		beq  ++

	+	iny
		bne  -					; loop should not be left this way
		;; jsr  panic				; (just for debugging :)

	+	pla						; line is comleted
		sta  last,x				; remember result of scan
		tya						; increase keycounter to next lines base
		and  #$f8
		clc
		adc  #8
		inx						; next line
		cpx  #8
		beq  +					; all done !
		tay
		jmp  _keyscan_main
          
	+	lda  #$ff
		sta  port_row			; reset port_row
		lda  port_row
		and  port_col
		cmp  #$ff				; disturbed by joystick ?
		beq  +					; shit, then throw it all away
	-	rts

	+	lda  keycode			; look at what we've found
		cmp  #$40
		bcs  -					; nothing ? So lets leave!
		sta  flag
		lsr  a
		lsr  a
		lsr  a
		tax
		lda  keycode
		and  #7
		tay
		lda  btab2i,y
		eor  #$ff
		ora  done,x				; mark this key, to ignore it next time
		sta  done,x

	-	; queue key into keybuffer
		ldx  keycode
		lda  altflags
		and  #keyb_lshift | keyb_rshift
		bne  ++
		lda  altflags
		and  #keyb_ctrl
		bne  +
		lda  _keytab_normal,x
		jmp  _addkey
	+	lda  _keytab_normal,x
		and  #$1f
		jmp  _addkey
	+	lda  _keytab_shift,x
_addkey:
		ldx  keycount
		bpl  +
		;; lda  module_id
		;; ldx  #0
		;; jsr  munblk				; unblkock waiting processes
		ldx #0  

	+ 	cpx  #keybuflen
		bcs  +					; overrun
		sta  _keybuffer,x
		inx
		stx  keycount
	+	rts

		;; stuff for accessing the scanned keys (and joysticks)

		;; get a charater from keyboard (non blocking, $00=no char)
keyb_getc:
		sei
		lda  _keybuffer
		pha						; remember top key
		txa
		pha
		ldx  keycount
		beq  +
		bmi  +
		ldx  #0
	-	lda  _keybuffer+1,x
		sta  _keybuffer,x
		inx
		cpx  keycount
		bne  -
		dec  keycount
		pla
		tax
		pla
		clc
		cli
		rts

	+	lda  #$80				; marker (unused jet)
		sta  keycount
		cli
		pla
		tax
		pla
		lda  #0
		rts

		;; get state of keyboard
keyb_stat: 
		sei
		lda  keycount
		and  #$7f
		cmp  #1
		lda  #0
		ror  a					; bit7=1, if there are pressed keys
		ora  altflags			; bit2..0= CTRL,right_SHIFT,left_SHIFT
		cli
		rts

		;; get state of joystick 0
keyb_joy0:  
		lda  joy0result
		eor  #$ff
		rts

		;; get state of joystick 1
keyb_joy1:  
		lda  joy1result
		eor  #$ff
		rts

		;; initialize and install keyboard scanning routine
keyboard_init:
		ldx  #<keyb_scan
		ldy  #>keyb_scan
		jsr  hook_irq			; hook into system
		lda  #$ff
		sta  port_row
		sta  port_col
		sta  port_row+2			; row is output
		lda  #0
		sta  port_col+2			; column is input (default after reset)
		ldx  #0
	-	lda  _startmsg,x
		beq  +
		jsr  printk
		inx
		bne  -
	+	rts

_startmsg:
		.asc "c64-kEYBOARD MODULE VERSION 1.0"
		.byte $0a,$00
